﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;

namespace BeforePopupTest
{
    public class Form1 : Form
    {
        #region Variables
        
        /// <summary>
        /// The Drop down box.
        /// </summary>
        private Syncfusion.Windows.Forms.Tools.ComboDropDown cbNewRateMultiplier;

        /// <summary>
        /// The grid we show when drop down is clicked.
        /// </summary>
        private GridControl m_productionRateGrid = null;

        #endregion

        #region Windows Form Designer generated code

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.cbNewRateMultiplier = new Syncfusion.Windows.Forms.Tools.ComboDropDown();
            ((System.ComponentModel.ISupportInitialize)(this.cbNewRateMultiplier)).BeginInit();
            this.SuspendLayout();
            // 
            // cbNewRateMultiplier
            // 
            this.cbNewRateMultiplier.IgnoreThemeBackground = true;
            this.cbNewRateMultiplier.Location = new System.Drawing.Point(116, 100);
            this.cbNewRateMultiplier.Name = "cbNewRateMultiplier";
            this.cbNewRateMultiplier.Size = new System.Drawing.Size(121, 21);
            this.cbNewRateMultiplier.SuppressDropDownEvent = false;
            this.cbNewRateMultiplier.TabIndex = 0;
            // 
            // Form1
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(353, 274);
            this.Controls.Add(this.cbNewRateMultiplier);
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.cbNewRateMultiplier)).EndInit();
            this.ResumeLayout(false);
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #endregion

        public Form1()
        {
            InitializeComponent();

            this.cbNewRateMultiplier.PopupContainer.AutoScroll = false;

            // set up the production rate grid
            this.m_productionRateGrid = new GridControl();
            this.m_productionRateGrid.Dock = DockStyle.Fill;
            this.m_productionRateGrid.AutoScrolling = ScrollBars.None;
            this.m_productionRateGrid.HScrollBehavior = GridScrollbarMode.Disabled;
            this.m_productionRateGrid.VScrollBehavior = GridScrollbarMode.Disabled;

            // add the production rate grid to a panel
            Panel panel = new Panel();
            panel.Dock = DockStyle.Fill;
            panel.BorderStyle = BorderStyle.Fixed3D;
            panel.AutoScroll = false;
            panel.Controls.Add(this.m_productionRateGrid);

            // set the panel as the control to popup in the combo box
            this.cbNewRateMultiplier.PopupControl = panel;

            // hook into BeforePopup event
            this.cbNewRateMultiplier.PopupContainer.BeforePopup += new CancelEventHandler(PopupContainer_BeforePopup);
        }

        /// <summary>
		/// Event that occurs when the new rate multiplier combo box is about to display it's drop down control.
		/// </summary>
		/// <param name="sender">The source object.</param>
		/// <param name="e">The <see cref="CancelEventArgs"/>.</param>
        private void PopupContainer_BeforePopup(object sender, CancelEventArgs e)
        {
            
            MessageBox.Show("EVENT FIRED!! YAY");

            //this event use to work with Synfusion 4.202.0.37
            //doesn't work with 5.102.1.0 though!!
        }
    }
}
